<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN"
          "http://www.w3.org/TR/REC-html40/loose.dtd">
<HTML>

<HEAD>
<TITLE>JFLA 99</TITLE>
</HEAD>

<BODY BGCOLOR="#FFFFFF">

<H1 ALIGN=CENTER>JFLA 99: relecture du papier 16</H1>

<P>
Numéro du papier: 16

Nom du papier et auteurs: OpenScheme et son débogueur, Guilhem de Wailly

<H2>1</H2>

<P>
Nom du rapporteur: Manuel Serrano

<P>Confiance en la note: 3

<P>Notation du papier: 1

<P>Commentaires aux auteurs:

<P>Dans son état actuel cet article n'est pas assez travaillé pour pouvoir
être publié. Il me semble qu'il faudrait changer un certain nombre de points
pour améliorer sa qualité. Voici, en vrac, plusieurs idées d'amélioration
et plusieurs remarques:

<PRE>
Titre: 
------
Le titre n'est pas cohérent avec le contenu de l'article. L'article ne
parle que du débogueur, pas du système OpenScheme.

Introduction:
-------------
La première phrase: "Les langages ... à un débogueur" semble être en 
contradiction avec la dernière phrase du premier paragraphe: "Il existe
peu ... un tel outil".

Le premier paragraphe est très creux. Tout le monde sait ce qu'est un
débogueur symbolique. Il n'est donc pas utile de le rappeler. En plus
énoncer des poncifs comme "C'est une aide au développement", "ça fait
gagner du temps" ne présente pas d'intérêt. On retrouve d'ailleurs ce
défaut en conclusion (mais j'y reviendrai). Indépendemment de sa forme,
je trouve que le 1er paragraphe n'est pas scientifiquement correct. 
DrScheme a un débogueur, Gambit a un débogueur, je suppose que Chez Scheme
a aussi un débogueur. Ces implantations font partie des implantations
"importantes" parce qu'elles font partie des implantations qui évoluent
et qui sont parmi les plus utilisées. Il est donc faux de dire que les
implantations Scheme n'ont pas de débogueur.

Note de bas de page:
--------------------
C'est très bien d'avoir une thèse mais ça n'est pas pertinent pour cet
article. C'est le contenu scientifique qui est intéressant, pas le reste.

Note Temporaire:
----------------
La note temporaire dit explicitement que le port Windows est en préparation
mais la dernière phrase de la première page dit que ce port existe déjà !
Ça existe ou ça n'existe pas ?

1. Présentation de OSM:
-----------------------
Première phrase: "OSM est un environnement de ... R4RS"
  - ce n'est pas totalement correct. 
    Par exemple le programme suivant n'est pas R4RS mais accepté par OSM:
       (display toto)
    (la variable toto n'est pas liée et le R4R spécifie que c'est une erreur
    de référencer une variable qui n'est pas définie).
    Par ailleurs en R4RS, call/cc n'est pas une forme spéciale mais une 
    fonction de la librairie (ça change tout).
La référence au R4RS n'est pas correcte. Ce n'est pas le R4RS qui est cité
là !

1er paragraphe, page 2:
"Parmi les bibliothèques ..., il y un moteur"
Qu'est-ce qu'un moteur de programmation ?

2eme paragraphe, page 2:
"Mais l'apport le plus marquant de OSM" 
Ce n'est qu'un avis mais il me semble que cette phrase devrait être supprimée.
Elle donne l'impression d'une certaine prétention de l'auteur et je crains
que ce soit le genre de phrase qui indispose un comité de lecture.

2. Exemple de débogage:
-----------------------
L'exemple de débogage n'est pas celui du code erroné présenté. Dans le code
erroné, il y a l'expression (fact (+ n 1)) mais dans le débug c'est l'expression
(fact (- n 1)) qu'on voit apparaître !

Plutôt que de présenter en une page des traces d'exécution, il me semble qu'il
faudrait les décrire un peu plus. Par exemple il faut expliquer les chiffres
entre parenthèses. C'est la position dans le source et c'est ça qui est 
important. Par ailleurs, il serait bien de présenter un peu le langage
du débogueur.

3. Réalisation du débogueur:
----------------------------
1er paragraphe, ligne 5:
Pourquoi n'est-il pas possible de générer du C qui garde un lien étroit
avec le code Scheme ? Ou plus exactement, cette affirmation est fausse. Il y
a des systèmes qui font ça !

3.1 Structures élémentaires : les acteurs
-----------------------------------------
Le terme acteur est maintenant mal choisi parce qu'il a acquis un sens précis
(c.f. objet et intelligence artificielle). 

Dans la structure `struct Actor', à quoi sert le #ifdef ? Puisque les
structures n'ont pas la même taille, le code de debug ne peut pas être
mélangé avec du code sans debug. 

Par ailleurs on ne comprend pas bien le rôle que joue cette structure Actor
parce qu'on ne sait pas très bien ce qu'est un "objet élémentaire". S'agit il
d'un objet de base Scheme ? On peut penser que c'est le cas mais alors cette
représentation a certains inconvénients qui ne sont pas présentés ici:
  - l'inefficacité  d'une telle implantation. Un entier, sur une
    machine à  base d'Alpha occupera 28 octets ! Je serai curieux de voir le
    temps de calcul de Fibonnacci avec une telle représentation. Tout le
    temps d'exécution va être passé dans les fonctions d'allocation et pas
    dans le contrôle. L'article _doit impérativement_ parler de ce pbm. Ça
    ne sert à rien d'avoir un débogueur s'il est tellement lent qu'on ne peut
    pas l'utiliser.
  - Si la position dans le source est codée dans chaque objet Scheme alors
    on aimerait voir l'implantation de la fonction eq?. Cette fonction ne
    peut plus être implantée comme une simple comparaison de pointeur. Là 
    encore c'est une grosse source d'inefficacité. L'article doit aussi
    parler de ce problème. C'est tout à fait anormal que des points aussi
    importants soient totalement négligés dans cette présentation.

3.2 Macro-expansion:
--------------------
Tout cette section n'a pas vraiment de justification parce que certains
des principaux Scheme actuellement distribués savent déjà faire ça depuis
assez longtemps. Je pense en particulier à DrScheme, Gambit et Bigloo. Il
y a donc 3 pages (sur 11) consacrées à présenter un problème déjà connu
et résolu depuis longtemps. En plus, ce qui est très gênant c'est que
l'article ne fait aucune référence à ces travaux.

3.3 Compilateur/codeur/interprète:
----------------------------------
Note de bas de page. Il est possible de faire de call/cc une forme
spéciale mais alors ce n'est plus du R4RS.

4. Conclusion:
--------------
1er paragraphe:
Oui, d'accord mais encore... Dire qu'un débogueur c'est bien c'est un
peu comme dire Scheme c'est bien. Ce n'est pas un argument. À quoi ça sert !

2eme paragraphe:
On a bien compris que le debug ralentit l'exécution dans OSM. On voudrait
savoir de combien. On voudrait des mesures.

3eme paragraphe:
"De plus, OSM ...4 de [2]" cf remarques précédentes.

4eme paragraphe:
cf remarque 1er paragraphe.

Bibliographie:
--------------
* Ref R4RS est fausse
* Ref PhD de Dybvig. Il y a une erreur dans le nom de Dybvig (un d à la fin)
et il manque la date.
</PRE>

<P>Commentaires réservés au comité de programme:

<P>Cet article est très mauvais:
<P>  - il est mal écrit
<P>  - il ne décrit que des choses largement connues et déjà 
    implantées dans les compilateurs Scheme depuis au moins 4 ans
<P>  - le contenu scientifique est très faible
<P>  - les choix d'implantation sont très douteux (à mon avis totalement
    inefficace) et absolument pas argumentés
<P>  - la faiblesse des références bibliographiques montre bien que l'auteur 
    ne sait pas ce qui se fait dans le domaine.


<H2>2</H2>

<P>Nom du rapporteur: Jose M. Piquer

<P>Confiance en la note: (de 1 à 3) 3
<P> (1 : je n'ai pas compris car ce n'est pas mon domaine.
<P>  2 : j'ai compris, mais je ne domine pas le sujet.
<P>  3 : j'ai tout compris car c'est mon domaine.)

<P>Notation du papier: (de 1 à 5) 2
<P> (1: à rejeter; 2: inintéressant; 3: acceptable;
<P>  4: bon papier; 5: très bon papier)

<P>Commentaires aux auteurs:

<P>Je crois que plus de details d'implantation seraient necessaires pour
comprendre bien la nouveaute' de ce systeme.

<P>Commentaires réservés au comité de programme:

<P>Il me semble que le papier est trop bref et trop simple.

</BODY>
</HTML>
